//
// SimpleVector.java
// Very simple vector with dot product.
// Copyright 2003 by Akkana Peck.
// You are free to use this under the terms of the GPL.
//

public class SimpleVector
{
    public double x, y, z;
    SimpleVector() { x = 0; y = 0; z = 0; }
    SimpleVector( double xx, double yy, double zz ) {
        x = xx;  y = yy;  z = zz;
    }

    public double dot(SimpleVector vec) {
        return x * vec.x + y * vec.y + z * vec.z;
    }

    public SimpleVector cross(SimpleVector v2) {
        return new SimpleVector(
            this.y*v2.z - this.z*v2.y,
            this.z*v2.x - this.x*v2.z,
            this.x*v2.y - this.y*v2.x);
    }

    public double Magnitude() {
        return(Math.sqrt(dot(this)));
    }

    public void NormalizeVector() {
        double magnitude = Magnitude();
        this.x /= magnitude;
        this.y /= magnitude;
        this.z /= magnitude;
    }

    public void OrthogonalizeVector(SimpleVector axis) {
        double projection = dot(axis);
        this.x -= projection*axis.x;
        this.y -= projection*axis.y;
        this.z -= projection*axis.z;
        NormalizeVector();
    }

    public String toString() {
        return "[ "
            + new Double(x) + ", " 
            + new Double(y) + ", " 
            + new Double(z) + "]";
    }
}


